/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.projects.model.tables


import cc.cinnamon.canary.projects.model.Keys
import cc.cinnamon.canary.projects.model.Public
import org.jooq.*
import org.jooq.impl.TableImpl

import javax.annotation.Generated
import java.util.Arrays


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:57:05.285Z", comments = "This class is generated by jOOQ")
class License private constructor(alias: String, aliased: Table<Record>, parameters: Array<Field<*>>? = null) : TableImpl<Record>(alias, null, aliased, parameters, "") {

    /**
     * The class holding records for this type
     */
    override fun getRecordType(): Class<Record> {
        return Record::class.java
    }

    /**
     * The column `public.license.id`.
     */
    val ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('license_id_seq'::regclass)", org.jooq.impl.SQLDataType.BIGINT)), this, "")

    /**
     * The column `public.license.name`.
     */
    val NAME = createField("name", org.jooq.impl.SQLDataType.VARCHAR.length(10), this, "")

    /**
     * The column `public.license.url`.
     */
    val URL = createField("url", org.jooq.impl.SQLDataType.VARCHAR.length(120), this, "")

    /**
     * The column `public.license.description`.
     */
    val DESCRIPTION = createField("description", org.jooq.impl.SQLDataType.CLOB, this, "")

    /**
     * Create a `public.license` table reference
     */
    constructor() : this("license", null) {
    }

    /**
     * Create an aliased `public.license` table reference
     */
    constructor(alias: String) : this(alias, LICENSE) {
    }

    /**
     * {@inheritDoc}
     */
    override fun getSchema(): Schema {
        return Public.PUBLIC
    }

    /**
     * {@inheritDoc}
     */
    override fun getIdentity(): Identity<Record, Long> {
        return Keys.IDENTITY_LICENSE
    }

    /**
     * {@inheritDoc}
     */
    override fun getPrimaryKey(): UniqueKey<Record> {
        return Keys.LICENSE_PKEY
    }

    /**
     * {@inheritDoc}
     */
    override fun getKeys(): List<UniqueKey<Record>> {
        return Arrays.asList(Keys.LICENSE_PKEY)
    }

    /**
     * {@inheritDoc}
     */
    override fun `as`(alias: String): License {
        return License(alias, this)
    }

    /**
     * Rename this table
     */
    override fun rename(name: String): License {
        return License(name, null)
    }

    companion object {

        private val serialVersionUID: Long = -2094726632

        /**
         * The reference instance of `public.license`
         */
        val LICENSE = License()
    }
}
